
/*****************************************************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		main.asm

Date Created:	09/04  Rev .10		Aseem V / Ramesh Babu

PURPOSE:	
					
This is an example code to demonstrate software overlays using the
BDMA memory space.The example has two overlay functions called
from "main.asm".


The overlay functions are:
1.Fast_LED_Blink :
				This code will blink LED at FL1 at a faster rate
2.Slow_LED_Blink :
				This code will blink LED at FL1 at slower rate
				
The program loops back infinitely so that the overlay functions are
brought in to the internal memory and executed one after another infinitely

Notes:
	1.Code has been tested on ADSP-2186EZ-KIT
	2.The FLASH memory used for DSP boot and storing the overlay code is M29W040B
	3.This requires some modifications on the EZ-KIT board since the board comes with a different PROM
	  				
-------------------------------------------------------------------------------------------------------*/






//Extern declarations
//_________________________________________________________________________________________________________________________
.extern Fast_LED_Blink;
.extern Slow_LED_Blink;
.extern BDMA_interrupt;
//_________________________________________________________________________________________________________________________



//IVT______________________________________________________________________________________________________________________
.section/pm interrupts;
	JUMP start; RTI; RTI; RTI;         	// Location 0x00: Reset Service Routine
      RTI; RTI; RTI; RTI;                         // Location 0x04: IRQ2 interrupt
      RTI; RTI; RTI; RTI;                         // Location 0x08: IRQL1 interrupt
      RTI; RTI; RTI; RTI;                         // Location 0x0C: IRQL0 interrupt
      RTI; RTI; RTI; RTI;                          // Location 0x10: SPORT0 transmit interrupt (TX)
      RTI; RTI; RTI; RTI;                         // Location 0x14: SPORT0 receive interrupt (RX)
      RTI; RTI; RTI; RTI;                         // Location 0x18: IRQE interrupt
      jump BDMA_interrupt; RTI; RTI; RTI;                          // Location 0x1C: BDMA interrupt
      RTI; RTI; RTI; RTI;                         // Location 0x20: SPORT1 transmit interrupt (TX) or IRQ1 for RS232
      RTI; RTI; RTI; RTI;                          // Location 0x24: SPORT1 receive interrupt (RX) or IRQ0
      RTI; RTI; RTI; RTI;                         // Location 0x28: Timer interrupt
      RTI; RTI; RTI; RTI; 			// Location 0x2C: Powerdown interrupt
//__________________________________________________________________________________________________________________________

//Main code starts here_____________________________________________________________________________________________________


.section/pm program;

  start:  
  
  	ifc = 0x00ff;		//clear pending interrupts
  	nop;
	imask = 8;		//set mask to enable BDMA interrupt
	ena ints;		//enable global interrupt

Infinite_Loop:
	
//Call the overlay fucntions here_____________________________________________________________________________________________

  	call Fast_LED_Blink;	//Live address is at 0x1000 in BM space
  	call Slow_LED_Blink;	//Live address is at 0x2000 in BM space
  	
  	jump Infinite_Loop;	//Call,download and execute the overlay code infinitely
  	
start.END:

//____________________________________________________________________________________________________________________________
